<div class="docs-primary-header component-page-header">
  <mat-chip-list>
    <mat-chip>
      <mat-icon>home</mat-icon>
      <a routerLink="/dashboard">Home</a> / Users
    </mat-chip>
  </mat-chip-list>
</div>

<!-- <button mat-fab (click)="sidenav1.toggle() && resetform()" class="float-button">
  <mat-icon matTooltip="Add User">add</mat-icon>
</button> -->

<div style="padding:15px;" class="appereance">
  <div class="example-container mat-elevation-z2 radius">
    <div class="title" >
      <span>USERS</span>
      <div style="flex-grow:1;"></div>

      <!-- <span *ngIf="checkUsers2.length!=0">
    <a routerLink="/mapusers" (click)="shareData(checkDistributor)" style="font-size: 16px;margin: 6px;">Map Users</a>&nbsp;
     </span> -->
   

     
        <!-- <a routerLink="/mapusers" *ngIf="checkUsers2.length==0" class="isDisabled" (click)="shareData(checkDistributor)" style="font-size: 16px;margin: 6px;">Map Users</a>&nbsp;
        <a routerLink="/mapusers" *ngIf="checkUsers2.length!=0" (click)="shareData(checkDistributor)" style="font-size: 16px;margin: 6px;">Map Users</a>&nbsp; -->


        <!-- <a *ngIf="checkDistributor.length==0" class="isDisabled" routerLink="/mapproducts" (click)="shareData(checkProduct)" style="font-size: 15px;padding-left: 24px;">Map Products</a>              
        <a *ngIf="checkDistributor.length!=0" routerLink="/mapproducts" (click)="shareData(checkProduct)" style="font-size: 15px;padding-left: 24px;">Map Products</a>              
     -->
      <!-- <button mat-raised-button style="cursor: pointer;" (click)="delete()" color="accent">DELETE</button>&nbsp;&nbsp; 
      <a routerLink="/deleted-user" (click)="shareData(checkDistributor)" style="font-size: 16px;padding-top: 9px;">Deleted Users</a> -->
    </div>
    <div class="example-header"> 
      <mat-form-field>
        <input matInput (keyup)="applyFilter($event.target.value)" placeholder="Filter">
      </mat-form-field>
    </div>
  <div class="new">
    <table mat-table [dataSource]="dataSource" matSort  matSort matSortActive="created" matSortDisableClear matSortDirection="asc" style="width: 100%">

      <ng-container matColumnDef="id">
        <mat-header-cell *matHeaderCellDef mat-sort-header> ID. </mat-header-cell>
        <mat-cell *matCellDef="let element; let i=index"> {{i+1}} </mat-cell>
      </ng-container>

     
      <ng-container matColumnDef="name">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Name </mat-header-cell>
        <mat-cell *matCellDef="let element"> {{element.name}} </mat-cell>
      </ng-container>

      <ng-container matColumnDef="mobile_no">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Mobile Number </mat-header-cell>
        <mat-cell *matCellDef="let element"> {{element.mobile_no}} </mat-cell>
      </ng-container>

      <!-- <ng-container matColumnDef="password">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Password </mat-header-cell>
        <mat-cell *matCellDef="let element"> {{element.password}} </mat-cell>
      </ng-container> -->

      <!-- <ng-container matColumnDef="email">
        <mat-header-cell *matHeaderCellDef mat-sort-header> E-Mail </mat-header-cell>
        <mat-cell *matCellDef="let element">
           {{element.email}} </mat-cell>
        <div style="margin-right: 25px; width: 63px;"> {{element.email}} </div>
      </mat-cell>
      </ng-container> -->

      <!-- <ng-container matColumnDef="address">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Address </mat-header-cell>
        <mat-cell *matCellDef="let element">
           {{element.address}} </mat-cell>
        <div style="margin-right: 25px; width: 63px;">{{element.address}}</div>
        </mat-cell>
      </ng-container> -->
 
      <!-- <ng-container matColumnDef="unique_code">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Unique Code </mat-header-cell>
        <mat-cell *matCellDef="let element"> {{element.unique_code}} </mat-cell>
      </ng-container> -->

      <!-- <ng-container matColumnDef="zipcode">
        <mat-header-cell *matHeaderCellDef mat-sort-header> zipcode </mat-header-cell>
        <mat-cell *matCellDef="let element"> {{element.zipcode}} </mat-cell>
      </ng-container> -->

      <ng-container matColumnDef="usertype">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Usertype </mat-header-cell>
        <mat-cell *matCellDef="let element">
          <mat-chip-list>
            <mat-chip *ngIf="element.usertype == 'User'" color="warn" selected="true">{{element.usertype}}</mat-chip>
          </mat-chip-list> 
        </mat-cell>
      </ng-container>

      <ng-container matColumnDef="contacts">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Contacts</mat-header-cell>
        <mat-cell *matCellDef="let row"><button mat-raised-button style="cursor: pointer; width: 55px;" (click)="openDialog(row.id)" color="primary">SHOW</button>
        </mat-cell>
      </ng-container>

      <ng-container matColumnDef="detail">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Other Details</mat-header-cell>
        <mat-cell *matCellDef="let row"><button mat-raised-button style="cursor: pointer; width: 55px;" (click)="openDialog2(row.id)" color="warn">SHOW</button>
        </mat-cell>
      </ng-container>

      <ng-container matColumnDef="map">
        <mat-header-cell *matHeaderCellDef mat-sort-header>Current Location </mat-header-cell>
        <mat-cell *matCellDef="let row">&nbsp;&nbsp;&nbsp;&nbsp;
          <a routerLink="/map/{{row.id}}"><mat-icon>location_on</mat-icon></a>
        </mat-cell>
      </ng-container>

      <!-- <ng-container matColumnDef="brand">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Brand </mat-header-cell>
        <mat-cell *matCellDef="let element"> {{element.brand_name}} </mat-cell>
      </ng-container>

      <ng-container matColumnDef="category">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Category </mat-header-cell>
        <mat-cell *matCellDef="let element"> {{element.category_name}} </mat-cell>
      </ng-container>

      <ng-container matColumnDef="sub_category">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Sub-Category </mat-header-cell>
        <mat-cell *matCellDef="let element"> {{element.sub_category_name}} </mat-cell>
      </ng-container> -->

      <!-- <ng-container matColumnDef="country">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Country </mat-header-cell>
        <mat-cell *matCellDef="let element"> {{element.country}} </mat-cell>
      </ng-container> -->

      <!-- <ng-container matColumnDef="actions">
        <mat-header-cell *matHeaderCellDef mat-sort-header> Actions </mat-header-cell>
        <mat-cell *matCellDef="let element">
          <button mat-icon-button>
            <mat-icon matTooltip="Edit" (click)="sidenav1.toggle()" (click)="edit(element.id, element.usertype)">edit
            </mat-icon>
          </button>

          <button mat-icon-button>
              <mat-icon matTooltip="Delete" (click)="onDelete(element.id)">delete
              </mat-icon>
            </button>
        </mat-cell>
      </ng-container> -->
 
      <!-- <ng-container matColumnDef="action">
        <mat-header-cell *matHeaderCellDef>
          <mat-checkbox (change)="alltogglecheck($event.checked,posts)"
          [checked]="allsel"   [indeterminate]="this.intsel > 0 ? true : false"
              >
          </mat-checkbox>
        </mat-header-cell>
        <mat-cell *matCellDef="let row">  
          <mat-checkbox  (change)="sendIDS($event.checked,row.id,posts.length)"
                        [checked]="sel">
          </mat-checkbox>
        </mat-cell>
      </ng-container> -->
<!-- 
      <ng-container matColumnDef="action"> 
        <mat-header-cell *matHeaderCellDef mat-sort-header> Select </mat-header-cell>
        <mat-cell *matCellDef="let element"><mat-checkbox (change)="sendIDS($event.checked,element.id)"(change)="sendIDS2($event.checked,element.id)" color="primary"></mat-checkbox></mat-cell>
      </ng-container> -->
     
      <!-- <ng-container matColumnDef="status">
          <mat-header-cell *matHeaderCellDef mat-sort-header>Status</mat-header-cell>
          <mat-cell *matCellDef="let row" ><a *ngIf="row.usertype != 'Customer'" [matTooltip]="(isHandset$ | async) ? '' : 'change status'"
            matTooltipPosition="right"><mat-slide-toggle [disabled]="row.usertype == 'Customer'" (change)="onchange($event.checked,row.id)" [checked]="row.allow_user==1?true:false"></mat-slide-toggle></a></mat-cell>
          
        </ng-container> -->

      <mat-header-row *matHeaderRowDef="['id', 'name', 'mobile_no',  'usertype','contacts','detail','map']"></mat-header-row>
      <mat-row *matRowDef="let row; columns: ['id', 'name', 'mobile_no',  'usertype','contacts','detail','map']"></mat-row>

    </table>
  </div>

    <!-- <mat-paginator [length]="100" [pageSize]="5" [pageSizeOptions]="[5, 10, 25, 100]"> -->
        <mat-paginator [length]="100000" [pageSize]="5000" [pageSizeOptions]="[5000, 10000,50000, 100000]">

    </mat-paginator>
  </div>
</div>


<mat-sidenav-container>

  <mat-sidenav #sidenav1 mode="over" opened="false" position="end">
    <mat-toolbar>
      <button mat-icon-button (click)="sidenav1.toggle() && resetform()">
        <mat-icon class="icon" matTooltip="Close">close</mat-icon>
      </button>
      <span style="margin-left: 15px;">ADD USER</span>
    </mat-toolbar>

    <div style="padding: 0 24px 24px 24px; margin-top: 10px;">
      <form [formGroup]="userForm">

        <mat-form-field>
          <input matInput placeholder="Name" formControlName="name">
          <mat-error *ngIf="userForm.controls['name'].hasError('required')">
            This field is
            <strong>required</strong>
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <input matInput #mobile_no minlength="10" maxlength="15" placeholder="Mobile Number" formControlName="mobile_no">
          <mat-hint align="end">{{mobile_no.value.length}} / 15</mat-hint>
          <mat-error *ngIf="userForm.controls['mobile_no'].errors?.pattern">
            Mobile Number should be numeric
          </mat-error>
          <mat-error *ngIf="userForm.controls['mobile_no'].hasError('required')">
            This field is
            <strong>required</strong>
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <input matInput placeholder="Password" formControlName="password" minlength="6">
          <mat-error *ngIf="userForm.controls['password'].hasError('required')">
            This field is
            <strong>required</strong>
          </mat-error>
          <mat-error *ngIf="userForm.controls['password'].hasError('minlength')">Password isn't long enough, minimum of 6 characters</mat-error>

        </mat-form-field>

        <mat-form-field>
          <input matInput #email maxlength="100" placeholder="E-Mail" formControlName="email">
          <mat-hint align="end">{{email.value.length}} / 100</mat-hint>
          <mat-error *ngIf="userForm.controls['email'].hasError('email') && !userForm.controls['email'].hasError('required')">
            Please enter a valid email address
          </mat-error>
          <mat-error *ngIf="userForm.controls['email'].hasError('required')">
            This field is
            <strong>required</strong>
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <input matInput placeholder="Address" formControlName="address">
          <mat-error *ngIf="userForm.controls['address'].hasError('required')">
            This field is
            <strong>required</strong>
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-select placeholder="Usertype" formControlName="usertype">
            <mat-option value="Manufacturer">Manufacturer</mat-option>
            <mat-option value="Distributor">Distributor / Importer</mat-option>
            <!-- <mat-option value="Retailer">Retailer</mat-option> -->
            <mat-option value="Customer">Customer</mat-option>
          </mat-select>
        </mat-form-field>

        <mat-form-field>
          <input matInput placeholder="Unique Code" formControlName="unique_code">
          <mat-error *ngIf="userForm.controls['unique_code'].hasError('required')">
            This field is
            <strong>required</strong>
          </mat-error> 
        </mat-form-field>

        <mat-form-field>
          <input matInput placeholder="zipcode" formControlName="zipcode">
          <mat-error *ngIf="userForm.controls['zipcode'].hasError('required')">
            This field is
            <strong>required</strong>
          </mat-error>
        </mat-form-field>

        <!-- <mat-form-field>
          <mat-select placeholder="Brand" formControlName="brand" required>
            <mat-option *ngFor="let brand of brands" [value]="brand.brand_id">
              {{ brand.brand_name }}
            </mat-option>
          </mat-select>
          <mat-error *ngIf="userForm.controls['brand'].hasError('required')">
            This field is
            <strong>required</strong>
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-select placeholder="Category" formControlName="category" (ngModelChange)="getSubCategory($event)" required>
            <mat-option *ngFor="let category of categories" [value]="category.category_id">
              {{ category.category_name }}
            </mat-option>
          </mat-select>
          <mat-error *ngIf="userForm.controls['category'].hasError('required')">
            This field is
            <strong>required</strong>
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-select placeholder="Sub-Category" formControlName="sub_category" required>
            <mat-option *ngFor="let subcategory of subcategories" [value]="subcategory.sub_category_id">
              {{ subcategory.sub_category_name }}
            </mat-option>
          </mat-select>
          <mat-error *ngIf="userForm.controls['sub_category'].hasError('required')">
            This field is
            <strong>required</strong>
          </mat-error>
        </mat-form-field> -->

        <!-- <mat-form-field>
          <input matInput placeholder="Category" formControlName="category">
          <mat-error *ngIf="userForm.controls['category'].hasError('required')">
            This field is
            <strong>required</strong>
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <input matInput placeholder="Sub-Category" formControlName="sub_category">
          <mat-error *ngIf="userForm.controls['sub_category'].hasError('required')">
            This field is
            <strong>required</strong>
          </mat-error>
        </mat-form-field> -->
<!-- 
        <mat-form-field>
          <input matInput placeholder="Country" formControlName="country">
          <mat-error *ngIf="userForm.controls['country'].hasError('required')">
            This field is
            <strong>required</strong>
          </mat-error>
        </mat-form-field> -->

    <mat-form-field>
          <mat-select placeholder="Country" formControlName="country" required>
                  <mat-option *ngFor="let country of countries" [value]="country">
                      {{country.name}}
                  </mat-option>
                </mat-select>
      <mat-error *ngIf="userForm.controls.country.errors?.required">Country is required</mat-error>
    </mat-form-field>



        
        <!-- sidenav1.toggle() &&  -->
        <div style="margin-top: 15px;">
          <a mat-raised-button (click)="resetform()" mat-raised-button color="accent" style="margin-left: 5px;">Reset</a>
          <button mat-raised-button color="accent" style="margin-left: 5px;" (click)=" sidenav1.toggle() && submit()" [disabled]="!userForm.valid || Hidden">Submit</button>
        </div>
      </form>
    </div>

  </mat-sidenav>
</mat-sidenav-container>